using System;
using System.Windows.Forms;
using System.Drawing;
using System.IO;

using SubSystems.ST;

namespace SubSystems.demo {

public class frmDemo: Form
{
   public static int Main(string[] args)
   {
      frmDemo frmDemoApp=new frmDemo();
      Application.Run(frmDemoApp);
      return 0;
   }

   private System.ComponentModel.Container components;
   private System.Windows.Forms.Button BtnSpellCheck;
   private System.Windows.Forms.Label Label1;
   private System.Windows.Forms.TextBox tbInput;
   private System.Windows.Forms.Label Label2;
   private System.Windows.Forms.TextBox tbOutput;
   private SpellTime SpellTime;

   public frmDemo()
   {
      this.Text="SpellTime Demo";
      InitializeComponents();

   }
   
   private void InitializeComponents()
   {
      this.components = new System.ComponentModel.Container();
      this.Size = new System.Drawing.Size(400,350);

      //////////////////////////////////////////////////////////////
      // Add controls to the form
      //////////////////////////////////////////////////////////////
      this.BtnSpellCheck = new System.Windows.Forms.Button();
      BtnSpellCheck.Location = new System.Drawing.Point(308,25);
      BtnSpellCheck.Size = new System.Drawing.Size(75,23);
      BtnSpellCheck.TabIndex = 0;
      BtnSpellCheck.Text="Spell Check";
      BtnSpellCheck.Click+=new System.EventHandler(this.BtnSpellCheck_Click);
      this.Controls.Add(BtnSpellCheck);

      this.Label1 = new System.Windows.Forms.Label();
      Label1.Location = new System.Drawing.Point(8,28);
      Label1.Size = new System.Drawing.Size(275,23);
      Label1.TabIndex = 0;
      Label1.Text="Enter text and click the 'Spell Check' button";
      this.Controls.Add(Label1);

      this.tbInput = new System.Windows.Forms.TextBox();
      tbInput.Location = new System.Drawing.Point(8,50);
      tbInput.Size = new System.Drawing.Size(375,23);
      tbInput.TabIndex = 0;
      this.Controls.Add(tbInput);

      this.Label2 = new System.Windows.Forms.Label();
      Label2.Location = new System.Drawing.Point(8,102);
      Label2.Size = new System.Drawing.Size(275,23);
      Label2.TabIndex = 0;
      Label2.Text="Misspelled words and suggestions";
      this.Controls.Add(Label2);

      this.tbOutput = new System.Windows.Forms.TextBox();
      tbOutput.Location = new System.Drawing.Point(8,125);
      tbOutput.Size = new System.Drawing.Size(375,185);
      tbOutput.TabIndex = 0;
      tbOutput.Multiline = true;
      this.Controls.Add(tbOutput);

      // Create a SpellTime object
      this.SpellTime = new SpellTime();

      //this.SpellTime.StSetFlags(true,SpellTime.STFLAG_NO_NUM_IN_WORD);

   }

   ///////////////////////////////////////////////////////////////////////////////
   //  Spell-Check button click
   ///////////////////////////////////////////////////////////////////////////////
   protected void BtnSpellCheck_Click(object sender, System.EventArgs e)
   {
      String CurLine=tbInput.Text;
      String CurWord;
      int WordIndex,CurIndex,LineLen,WordCount,errors;
      int ResultCode=0;
      
      LineLen=CurLine.Length;
      CurIndex=WordIndex=0;            // scan from the first character
      CurWord="";
      WordCount=errors=0;

      //SpellTime.StSetFlags(true,SpellTime.STFLAG_FRENCH_DLG);

      //SpellTime.StSwitchDict("dict35_spn\\dict35.d");      // example of swtiching a dictionary

      while (SpellTime.StParseLine(CurLine, ref CurWord, ref WordIndex, ref CurIndex,LineLen)>0) {

         if (!SpellTime.SpellWord(CurWord,SpellTime.ST_INTERACTIVE,out ResultCode)) {
             if (errors==0) tbOutput.AppendText("Misspelled words: \n \n");
              
             tbOutput.AppendText("\n");
             
             tbOutput.AppendText("Word: "+CurWord+"\n");
             if (True(ResultCode&(SpellTime.ST_REPLACE|SpellTime.ST_INPUT)))
                tbOutput.AppendText("   Replacement word: "+SpellTime.StGetReplacement()+"\n");
             
             if (True(ResultCode&(SpellTime.ST_IGNORE))) {
               if (True(ResultCode&(SpellTime.ST_ALL)))
                tbOutput.AppendText("   Ignored All\n");
               else tbOutput.AppendText("   Ignored \n");
             }

             if (True(ResultCode&SpellTime.ST_REPLACE) && True(ResultCode&SpellTime.ST_ALL))
                tbOutput.AppendText("   Change All\n");

             if (True(ResultCode&SpellTime.ST_ADD))
                tbOutput.AppendText("   Added to the user dictionary\n");

             tbOutput.AppendText("   Number of suggested words: "+SpellTime.StGetAlternateWordCount().ToString()+"\n");
             
             tbOutput.AppendText("\n");

             errors++;
         }
      
         WordCount++;
      }

      tbOutput.AppendText(" \nWords checked: "+WordCount+" misspelled words: "+errors+"\n");
   }
    
   public bool WriteTestFile()
   {
      FileStream oStream=new FileStream("test.txt",FileMode.OpenOrCreate,FileAccess.Write);
      int i,n=300;

      char[] chr;
  
      chr = new char[n];

      for (i=0;i<198;i++) chr[i]=(char)(127+i);
      chr[197]=(char)4000;
      chr[198]=(char)8000;
      chr[199]=(char)0;

      String str = new String(chr);

      //byte[] bt;
      //bt=(byte[])chr;

      //oStream.Write(bt,0,200);

      oStream.Close();

      return true;
   }

   ///////////////////////////////////////////////////////////////////////////////////////////////////////////
   ////////// Helper Functions
   //////////////////////////////////////////////////////////////////////////////////////////////////////////
   /******************************************************************************
       Boolean funtions:
   *******************************************************************************/
   bool True(int val)
   {
      return (val!=0);
   }
   bool False(int val)
   {
      return (val==0);
   }

}

} 
